DECLARE SUB calculate (s!, k!, h1!, h2!, L1!, H!, x1!, L!, x!, t!, U!, Tdimensional!, um!, C!)
DECLARE SUB manning (h1!, h2!, s!, k!, C!, um!)
DECLARE SUB hydro (hs!, x!, k!, L!, U!, row%, a!(), H)
DECLARE SUB shape (h1!, n!, k!, L, U)
DIM hydrotheor(150, 2)
DIM hydrographTimes(100)
DIM hydrographHeights(100)
DIM lht(100), lhh(100)

CLS

'===========================================================================
'     Print a title on the screen
'===========================================================================
PRINT ""
PRINT ""
PRINT "                       U.S. DEPARTMENT OF THE INTERIOR"
PRINT "                           U.S. GEOLOGICAL SURVEY"
PRINT ""
PRINT ""
PRINT "                   KWM -- A BASIC program for a kinematic"
PRINT "                        wave model for debris flows"
PRINT ""
PRINT ""
PRINT "                                    by"
PRINT ""
PRINT "                    Massimo Arattano and Philip S. Powers"
LOCATE 25, 1
COLOR 0, 7
PRINT "press any key to continue";
COLOR 7, 0

DO WHILE INKEY$ = ""
LOOP

CLS
LOCATE 5, 1
COLOR 31, 0
PRINT "                              *** IMPORTANT ***"
LOCATE 10, 1
COLOR 7, 0
PRINT "                 If you need to quit the program at any time press and"
PRINT "                 hold [CTRL] and then press [BREAK] ";
LOCATE 22, 1
COLOR 7, 0
PRINT "to continue with the program ";
COLOR 0, 7
PRINT "PRESS ANY KEY."
COLOR 7, 0
DO WHILE INKEY$ = ""
LOOP

CLS

doagn:
CLS
ans = 0
LOCATE 10, 5
PRINT "Do you want to "
PRINT
PRINT " (1)   Compute parameters of the model using two recorded hydrographs?"
PRINT " (2)   input parameters of your own? ";
PRINT ""
PRINT ""
INPUT " Enter 1 or 2                           ", ans
IF ans < 1 OR ans > 2 THEN GOTO doagn:

IF ans = 1 THEN
        GOTO Indata:
ELSE
        INPUT "Enter the slope of the channel.  ", s
        INPUT "Enter K (exponent of the hydraulic radius).  ", k
        INPUT "Enter the coefficient C.  ", C
        INPUT "Enter the height, H, of the initial debris mass.  ", H
        L = H / s
        U = C * H ^ k * s ^ .5

redo:
        PRINT " Do you want to draw an hydrograph at a certain distance from the  "
        INPUT " theoretical point of inception of the debris flow (Y/N) ?  ", b$
        b$ = UCASE$(LEFT$(b$, 1))
         IF b$ <> "N" AND b$ <> "Y" THEN GOTO redo:
hydrcal1:

        IF b$ = "Y" THEN
            INPUT "Enter the number of points of the hydrograph.  ", row%
            INPUT "Enter the distance at which you want the hydrograph.  ", x1
            xx = x1 / L
            aa = (k + 1) / (2 * k)
            bb = (1 - k) / (2 * k)
            hs = (-xx + SQR(xx ^ 2 + 4 * aa * bb)) / (2 * bb)
            hs = hs * H
            CALL hydro(hs, xx, k, L, U, row%, hydrotheor(), H)
        END IF
      
redo1:

        ans$ = ""
        INPUT "Would you like to compute another theoretical hydrograph (Y/N).  ", ans$
        ans$ = UCASE$(LEFT$(ans$, 1))
        IF ans$ <> "N" AND ans$ <> "Y" THEN GOTO redo1:
        IF ans$ = "Y" THEN
           CLS
           GOTO hydrcal1:
        END IF
             
        GOTO done1:
END IF

Indata:

CLS
INPUT "Enter the Distance between the 2 gaging stations.  ", L1
INPUT "Enter the slope of the channel.  ", s
INPUT "Enter the peak height at the first station.  ", h1
INPUT "Enter the peak height at the second station.  ", h2
INPUT "Enter an attempt value for K (exponent of the hydraulic radius).  ", k
INPUT "Enter the mean velocity in the reach.   ", um
CLS
CALL calculate(s, k, h1, h2, L1, H, x1, L, x, t, U, Tdimensional, um, C)

theight$ = ""
loopagain:

IF theight$ = "" THEN
   drive$ = CURDIR$
   PRINT "The current drive and working directory are "; drive$
   PRINT "This will be the location of your input and output files."
   PRINT "Press ";
   COLOR 0, 7
   PRINT "[RETURN]";
   COLOR 7, 0
   PRINT " to accept the current drive and working directory,"
   INPUT "or else enter the new drive and path. ", dp$

   IF dp$ = "" THEN
      dp$ = drive$
   END IF
   
   INPUT "Enter the name of the input file with time, height data. "; theight$
END IF

IF datafilename$ = "" THEN
   INPUT "Enter the output filename for corrected hydrograph data (station A).  "; datafilename$
ELSE
   GOTO done:
END IF

CLS
ON ERROR GOTO error1:
OPEN dp$ + datafilename$ FOR INPUT AS #5
ON ERROR GOTO 0
CLOSE #5
PRINT

'File already existed, make selection to overwrite, append or select new name.

IF UCASE$(LEFT$(cont$, 1)) <> "Y" THEN
   COLOR 0, 7
   PRINT dp$ + datafilename$; " already exits."
   COLOR 7, 0
   ans$ = ""

   DO WHILE ans$ <> "Y" AND ans$ <> "A" AND ans$ <> "N"
         INPUT "Enter Y = Overwrite, A = Append, or else N to enter a different name. ", kpress$
         ans$ = UCASE$(kpress$)
   LOOP
   IF ans$ = "N" THEN
       datafilename$ = ""
       GOTO loopagain:
   END IF

   IF ans$ = "Y" THEN
            KILL dp$ + datafilename$
            GOTO proceed:
   END IF

   IF ans$ = "A" THEN
            append$ = "A"
            GOTO proceed:
   END IF

           datafilename$ = ""
           GOTO done:
END IF

proceed:
ON ERROR GOTO 0

IF append$ = "A" OR cont$ = "Y" THEN
         CLOSE #5
         OPEN dp$ + datafilename$ FOR APPEND AS #5
         append$ = ""
ELSE
         OPEN dp$ + datafilename$ FOR OUTPUT AS #5
END IF

done:


OPEN dp$ + theight$ FOR INPUT AS #4
ct% = 0

ON ERROR GOTO errendfile1:
WHILE NOT EOF(4)
   ct% = ct% + 1
   INPUT #4, hydrographTimes(ct%), hydrographHeights(ct%)

   IF hydrographTimes(ct%) = 0 AND hydrographHeights(ct%) = 0 THEN
      ct% = ct% - 1
      GOTO endfile1:
   END IF

WEND
endfile1:  ON ERROR GOTO 0

CLOSE #4
n = ct%

FOR i = 1 TO n
   hydrographTimes(i) = hydrographTimes(i) + Tdimensional
NEXT i

sumxy = 0
sumx = 0
sumy = 0
sumxi = 0
sumyi = 0
sumx2 = 0
sumy2 = 0
FOR i = 1 TO n
        lht(i) = LOG(hydrographTimes(i))
        lhh(i) = LOG(hydrographHeights(i))
        '
        'Compute the SUMS necessary to calculate the linear regression line.
        '
        sumxy = sumxy + lht(i) * lhh(i)
        sumx = sumx + lht(i)
        sumy = sumy + lhh(i)
        sumxi = sumxi + lht(i) / ct%
        sumyi = sumyi + lhh(i) / ct%
        sumx2 = sumx2 + lht(i) ^ 2
        sumy2 = sumy2 + lhh(i) ^ 2
NEXT i

'CSCP is the computed sum of the cross product.
cscp = sumxy - (sumx * sumyi)
cssx = sumx2 - (sumx * sumxi)
cssy = sumy2 - (sumy * sumyi)
slopem = cscp / cssx
intercept = sumyi - (slopem * sumxi)
corrcoef = ABS(cscp / (cssx * cssy) ^ .5)
Knew = -1 / (slopem)
IF ABS(Knew - k) > .00001 THEN
   CLOSE #4
   k = Knew
   CALL calculate(s, k, h1, h2, L1, H, x1, L, x, t, U, Tdimensional, um, C)
   GOTO loopagain:
ELSE
   GOTO loopout:
END IF

loopout:

FOR i = 1 TO n
        PRINT #5, USING "#####.### ####.###"; hydrographTimes(i); hydrographHeights(i)
NEXT i

CLS
PRINT USING "Intercept is:                ####.###     "; intercept
PRINT USING "Correlation coefficient (r):    #.###   "; corrcoef
PRINT
PRINT
PRINT "  Mean      Peak      Peak"
PRINT "Velocity   Height    Height    "
PRINT " in the    at 1st    at 2nd    Dist.  "
PRINT " Reach    Station   Station     x       H       L      t        k      C"
PRINT "  (m)       (m)       (m)      (m)     (m)     (m)    (s) "
PRINT "--------------------------------------------------------------------------"
PRINT USING " ##.##    ##.##     ##.##      ###.#  ##.##   ##.## ####.#   #.####  ##.##"; um; h1; h2; x1; H; L; Tdimensional; k; C
PRINT
PRINT
PRINT "Enter (Y)es to send screen to printer (LPT1) else press any key.  "
ans$ = ""
DO WHILE ans$ = ""
  ans$ = INKEY$
LOOP
ans$ = UCASE$(LEFT$(ans$, 1))

IF ans$ = "Y" THEN
   OPEN "lpt1:" FOR OUTPUT AS #10
   PRINT #10, USING "Intercept is:                 ####.### "; intercept
   PRINT #10, USING "Correlation coefficient (r):     #.#### "; corrcoef
   PRINT #10, "  Mean      Peak      Peak"
   PRINT #10, "Velocity   Height    Height    "
   PRINT #10, " in the    at 1st    at 2nd    Dist.  "
   PRINT #10, " Reach    Station   Station     x       H       L      t       k      C"
   PRINT #10, "  (m)       (m)       (m)      (m)     (m)     (m)    (s) "
   PRINT #10, "------------------------------------------------------------------------"
   PRINT #10, USING " ##.##    ##.##     ##.##      ###.#  ##.##   ##.## ####.#   #.####  ##.##"; um; h1; h2; x1; H; L; Tdimensional; k; C
   PRINT #10, CHR$(12)
   CLOSE #10
END IF

redo2:

INPUT "Do you want to generate a hydrograph (Y/N) ?  "; a$
a$ = UCASE$(LEFT$(a$, 1))
IF a$ <> "N" AND a$ <> "Y" THEN GOTO redo2:
hydrocal:
CLS
IF a$ = "Y" THEN
        PRINT "Enter 1 to calculate theoretical hydrograph at the first station.  "
        PRINT "Enter 2 to calculate theoretical hydrograph at the second station.  "
        PRINT "Enter 3 to calculate theoretical hydrograph at a designated distance"
        INPUT "        from the theoretical point of inception of the debris flow.         ", ch!

        SELECT CASE ch!
        CASE 1
           hs = h1
           xx = x
        CASE 2
           hs = h2
           xx = x + L1 / L
        CASE 3
            INPUT "Enter the distance at which you want the hydrograph.  "; x1
            xx = x1 / L
            aa = (k + 1) / (2 * k)
            bb = (1 - k) / (2 * k)
            hs = (-xx + SQR(xx ^ 2 + 4 * aa * bb)) / (2 * bb)
            hs = hs * H

         CASE ELSE
          GOTO hydrocal:
        END SELECT

CLS
inrow:
INPUT "Enter the number of points on the theoretical hydrograph.  "; row%

IF row% > 150 THEN
   PRINT "Input must be less than or equal to 150."
   GOTO inrow:
END IF

IF row% = 0 THEN
   GOTO inrow:
END IF

           CALL hydro(hs, xx, k, L, U, row%, hydrotheor(), H)
END IF

IF a$ = "Y" THEN
        CLS
redo3:
  
        INPUT "Would you like to compute another theoretical hydrograph (Y/N)?  "; ans$
        ans$ = UCASE$(LEFT$(ans$, 1))
        IF ans$ <> "N" AND ans$ <> "Y" THEN GOTO redo3:

        IF ans$ = "Y" THEN
           CLS
           GOTO hydrocal:
        END IF

END IF
CLS
IF a$ = "Y" THEN
        PRINT "Enter (Y)es if you would like to correct the data of the "
        PRINT "recorded hydrograph at station B with the calculated value of t,"
        INPUT "otherwise enter (N)o.  "; ans$
        ans$ = UCASE$(LEFT$(ans$, 1))
        IF ans$ <> "Y" THEN GOTO opt:
           INPUT "Enter the input filename of hydrograph data from station B.  "; theight2$
loopagain2:
        INPUT "Enter the output filename for corrected hydrograph data (station B).  "; datafilename2$
        CLOSE #5
        CLS
        ON ERROR GOTO error2:
        OPEN dp$ + datafilename2$ FOR INPUT AS #5
        ON ERROR GOTO 0
        CLOSE #5
        PRINT

        'File already existed, make selection to overwrite, append or select new name.

        IF UCASE$(LEFT$(cont$, 1)) <> "Y" THEN
           COLOR 0, 7
           PRINT dp$ + datafilename2$; " already exits."
           COLOR 7, 0
           ans$ = ""

           DO WHILE ans$ <> "Y" AND ans$ <> "A" AND ans$ <> "N"
                 INPUT "Enter Y = Overwrite, A = Append, or else N to enter a different name. "; ans$
                 ans$ = UCASE$(LEFT$(ans$, 1))
           LOOP

           IF ans$ = "N" THEN GOTO loopagain2:

           IF ans$ = "Y" THEN
                 KILL dp$ + datafilename2$
                 GOTO proceed2:
           END IF

           IF ans$ = "A" THEN
                 append$ = "A"
                 GOTO proceed2:
           END IF

                datafilename2$ = ""
                GOTO done2:
        END IF

proceed2:
        ON ERROR GOTO 0

        IF append$ = "A" OR cont$ = "Y" THEN
                 CLOSE #5
                 OPEN dp$ + datafilename2$ FOR APPEND AS #5
                 append$ = ""
        ELSE
                 OPEN dp$ + datafilename2$ FOR OUTPUT AS #5
        END IF

done2:
     
        OPEN dp$ + theight2$ FOR INPUT AS #4
        DIM hydrographTimes2(100)
        DIM hydrographHeights2(100)
        ct% = 0
        ON ERROR GOTO errendfile2:

        WHILE NOT EOF(4)
                ct% = ct% + 1
                INPUT #4, hydrographTimes2(ct%), hydrographHeights2(ct%)

                IF hydrographTimes2(ct%) = 0 AND hydrographHeights2(ct%) = 0 THEN
                   ct% = ct% - 1
                   GOTO endfile2:
                END IF



        WEND

endfile2:  ON ERROR GOTO 0

        CLOSE #4
        n = ct%
        ti = L1 / um

        FOR i = 1 TO n
                hydrographTimes2(i) = hydrographTimes2(i) + Tdimensional + ti
                PRINT #5, USING "#####.### ####.###"; hydrographTimes2(i); hydrographHeights2(i)
        NEXT i

END IF

opt:

PRINT "Press Space bar to RUN program again, or any other key to EXIT."
PRINT "";
s$ = ""

DO WHILE s$ = ""
    s$ = INKEY$
LOOP

'
' ASCII character 32 is the space bar.
'
IF s$ = CHR$(32) THEN
   CLS
    datafilename$ = ""
    datafilename2$ = ""
   CLOSE #1, #2, #3, #4, #5, #6, #7, #8, #9, #10
   GOTO doagn:
ELSE
   CLS
   GOTO done1:
END IF

done1:
CLS
LOCATE 11, 17
COLOR 0, 7
PRINT "                                          "
LOCATE 12, 17
PRINT "                ALL DONE.                 "
LOCATE 13, 17
PRINT "                                          "
COLOR 7, 0
BEEP
BEEP
BEEP
terminate:
CLOSE #1, #2, #3, #4, #5, #6, #7, #8, #9, #10
END

error1:

IF ERR = 53 THEN
        OPEN dp$ + datafilename$ FOR OUTPUT AS #5
        cont$ = "Y"
        RESUME done:
END IF

 PRINT "ERROR DETECTED.  "; ERR
 PRINT "LINE DETECTED.  "; ERL
 PRINT "Debug and restart program."
 GOTO terminate:

error2:

IF ERR = 53 THEN
        OPEN dp$ + datafilename2$ FOR OUTPUT AS #5
        cont$ = "Y"
        RESUME done2:
END IF

 PRINT "ERROR DETECTED.  "; ERR
 PRINT "LINE DETECTED.  "; ERL
 PRINT "Debug and restart program."
 GOTO terminate:

errendfile1:

IF ERR = 62 THEN
   ct% = ct% - 1
   RESUME endfile1
END IF

PRINT "ERROR DETECTED.  "; ERR
PRINT "LINE DETECTED.  "; ERL
PRINT "Debug and restart program."
GOTO terminate:

errendfile2:

IF ERR = 62 THEN
   ct% = ct% - 1
   RESUME endfile2
END IF

PRINT "ERROR DETECTED.  "; ERR
PRINT "LINE DETECTED.  "; ERL
PRINT "Debug and restart program."
GOTO terminate:

SUB calculate (s, k, h1, h2, L1, H, x1, L, x, t, U, Tdimensional, um, C)
        H = SQR((L1 * s + (k - 1) / (2 * k) * (h1 - h2)) / ((k + 1) / (2 * k) * ((1 / h2) - (1 / h1))))
        x1 = 1 / s * ((k + 1) / (2 * k * h1) * H ^ 2 - (1 - k) / (2 * k) * h1)
        L = H / s
        x = x1 / L
        t = (1 - (h1 / H) ^ 2) / (2 * k * (h1 / H) ^ (k + 1))
        CALL manning(h1, h2, s, k, C, um)
        U = C * H ^ k * s ^ .5
        Tdimensional = t * L / U

END SUB

SUB hydro (hs, x, k, L, U, row%, a(), H) STATIC
       ' subroutine to compute heights for
       ' different times at the same x
 
p = (hs / H) / (row% + 2)
INPUT "Enter the output filename for the theoretical hydrograph (dimensional).  ", filehydro1$

redo4:

INPUT "Do you also want to generate a non dimensional hydrograph (Y/N)  ", kk$
kk$ = UCASE$(LEFT$(kk$, 1))
IF kk$ <> "N" AND kk$ <> "Y" THEN GOTO redo4:
IF kk$ = "Y" THEN
  INPUT "Enter the output filename for theoretical hydrograph (non dimensional).  ", filehydro2$
  OPEN filehydro2$ FOR OUTPUT AS #8
END IF

 OPEN filehydro1$ FOR OUTPUT AS #7

FOR i = 1 TO row%
    a(i, 2) = ((hs / H) - (row% - i) * p)
    a(i, 1) = (x - a(i, 2)) / ((k + 1) * (a(i, 2) ^ k))
   
    IF kk$ = "Y" THEN
       PRINT #8, USING "#####.### ####.###"; a(i, 1); a(i, 2)
    END IF
   
    PRINT #7, USING "#####.### ####.###"; a(i, 1) * L / U; a(i, 2) * H
NEXT i
CLOSE #7, #8
END SUB

SUB manning (h1, h2, s, k, C, um)

' SUBROUTINE per il calcolo di C (coeff. di scabrezza) in
' funzione delle altezze dei due idrogrammi

C = um / (((h1 + h2) / 2) ^ k * s ^ .5)

END SUB

